<?php

/*  print_view.php: Clean view of a message part for printing
*
    Copyright (C) 2002,2003,2004  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: print_view.php,v 1.29 2004/08/13 04:10:26 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'print_view');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get unseen status */
$unseen = hm_unseen_status($imap_stream, $_SESSION['folders']);

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* get message headers */
$message_headers = hm_get_full_header($imap_stream, $hm_input['uid'], false);

/* bail if the message is gone */
if (empty($message_headers)) {
    $_SESSION['notices'][] = $str[256].'<br>'.$str[218];
    header("Location: ".$config['hostname'].$config['install_path'].
       "mailbox.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
    exit;
}

/* get message structure */
$structure = hm_get_struct($imap_stream, $hm_input['uid']);

/* check for full message display on LARGE message parts */
if (isset($hm_input['big_text'])) {
    $cutoff = false;
}
else {
    $cutoff = true;
}

/* set date format */
if (isset($_SESSION['settings']['date_string'])) {
    $date_string = $_SESSION['settings']['date_string'];
}
else {
    $date_string = 'g:i a, F j, Y';
}

/* full header views */
if (isset($hm_input['print_full']) && $hm_input['print_full'] == 'true') {
    $full = '&amp;full=yes';
}
else {
    $full = '';
}
if (!isset($hm_input['part'])) {
    $part = 0;
    /* blah, html default option! */
    if (isset($_SESSION['settings']['html_default']) &&
        $_SESSION['settings']['html_default'] == 'true') {
        foreach ($structure as $index => $array) {
            if (isset($array['subtype']) && $array['subtype'] == 'html') {
                $part = $index;
                break;
            }
        }
    }
}
else {
    $part = $hm_input['part'];
}
if (isset($hm_input['parts'])) {
    $parts = '&amp;parts='.$hm_input['parts'];
}
else {
    $parts = '';
}
if (isset($hm_input['raw'])) {
    $raw_value = '&amp;raw=1';
}
else {
    $raw_value = '';
}
/* message header and body display */
echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>
      Print View
  </title>
  <meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=',$str['charset'],'">
  <link rel="SHORTCUT ICON" href="../images/hastymail.ico">
</head>
<body>
<br>
<table align="center" width="95%">
   <tr>
      <td>
      <small><a href="message.php?id=',$hm_input['id'],
      '&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
      '&amp;mailbox=',urlencode($hm_input['mailbox']),$full,$parts,
      $raw_value,'">
      ',$str[91],'
      </a></small>
      </td>
   </tr>
</table>
<br>',"\n"; 

if (isset($hm_input['print_full']) && !isset($hm_input['raw'])) {
    echo '<table width="95%" cellpadding="0" cellspacing="0">',"\n";
    foreach ($message_headers as $name => $val) {
        echo '
   <tr>
      <td align="right" valign="top">
      <small>',preg_replace("/_\d*$/", '', $name),':</small>
      </td> 
      <td>
      &nbsp;<small>',$val,'</small>
      </td> 
   </tr>',"\n";
    }
    echo "</table>\n";
}
elseif (!isset($hm_input['raw'])) {
    if (isset($message_headers['subject']) && $message_headers['subject'] != '') {
        $subject = $message_headers['subject'];
    }
    else {
        $subject = $str[229];
    }
    if (isset($message_headers['date']) && $message_headers['date'] != '') {
        $date = date($date_string, (strtotime($message_headers['date'])));
    }
    else {
        $date = $str[231];
    }
    if (isset($message_headers['from']) && $message_headers['from'] != '') {
        $from = $message_headers['from'];
    }
    else {
        $from = $str[230];
    }
    if (isset($message_headers['to']) && $message_headers['to'] != '') {
        $to = $message_headers['to'];
    }
    else {
        $to = $str[232];
    }
    if (isset($message_headers['cc']) && $message_headers['cc'] != '') {
        $cc = $message_headers['cc'];
    }
    else {
        $cc = false;
    }
    echo '<table width="95%" align="center">
   <tr>
      <td>
      ',$str[21],':
      </td>
      <td>',
      $subject,'
      </td>
   </tr>
   <tr>
      <td>
      ',$str[23],':
      </td>
      <td>',
      $date,'
      </td>
   </tr>
   <tr>
      <td>
      ',$str[22],':
      </td>
      <td>',
      $from,'
      </td>
   </tr>
   <tr>
      <td>
      ',$str[25],':
      </td>
      <td>',
      $to,'
      </td>
   </tr>
</table>',"\n";
}
/* if raw message view is selected */
if (isset($hm_input['raw']) && $hm_input['raw'] == 1) {
    $text_part = hm_get_message_part($imap_stream, $hm_input['uid'], 'raw');
    echo '             <td>
             <table width="97%" align="center">
                <tr>
                   <td>
                   <pre>',hm_htmlize($text_part),'</pre>
                  </td>
               </tr>
            </table>
            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
<table width="95%" align="center"> ',"\n";
}
else {
    $part_search = false;
    if (isset($hm_input['parts'])) {
        $message_parts = explode(',', $hm_input['parts']);
    }
    elseif ($part > 0) {
        $message_parts = array($hm_input['part']);
    }
    else {
        $part_search = true;
        $message_parts = array(1);
    }
    $start = true;
    $actual_parts = array();
    $displayed = array();
    foreach ($message_parts as $val) {
        if ($start) {
            $start = false;
        }
        else {
            echo '      <br><hr align="left" width="80%"><br>';
        }
        if (!$part_search) {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                            $val, false, false, $cutoff);
        }
        else {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                             false, false, false, $cutoff);
            if ($results[1] == "\n\n     ".$str[194]."\n\n" && 
                $structure[1]['type'].$structure[1]['subtype'] == 'texthtml' &&
                isset($_SESSION['settings']['html_only']) &&
                $_SESSION['settings']['html_only'] == 'true') {
                $results = &hm_find_display_part($imap_stream, $structure, 
                                                 $hm_input['uid'], 1, false, false,
                                                 $cutoff);
            }
        }
        $hm_input['part']= $results[0];
        $text_part = $results[1];
        $decode    = $results[2][0];
        $type      = $results[2][1];
        $subtype   = $results[2][2];
        $dsp_type  = $results[2][3];
        if (isset($results[2][5]) && $results[2][5]) {
            $name = $results[2][5];
        }
        /* setup charset mechanism */
        $code_page = false;
        $charset_convert = false;
        $charset = false;
        $utf = false;
        if (isset($results[2][4]) && $results[2][4] && $str['charset'] == 'UTF-8') {
            $charset = strtolower($results[2][4]);
            if (isset($_SESSION['charsets'][$charset])) {
                $code_page = $_SESSION['charsets'][$charset];
                $charset_convert = true;
            }
        }
        if ($charset == 'utf-8') {
            $utf = true;
        }
        /* check for rfc header information on nested parts */
        if (strstr($hm_input['part'], '.') && array_key_exists(1, $structure) &&
            !in_array(substr($hm_input['part'], 0, strrpos($hm_input['part'], '.')),
            $displayed)) {
            $value = &hm_in_multi_array($hm_input['part'], $structure, array(), true); 
            $part_headers = hm_get_full_header($imap_stream, $hm_input['uid'], $value[0]);
            /* check for mailing list header */
            if (isset($part_headers['list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            elseif (isset($part_headers['x-list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['x-list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            else {
                $list_reply = false;
            }
        
            /* rfc message headers */
            if (is_array($part_headers)) {
                $feilds = array ('subject', 'from', 'date');
                if (isset($hm_input['print_full']) && $hm_input['print_full'] == 'true') {
                    echo '      <table cellpadding="1" cellspacing="1">',"\n";
                    foreach ($part_headers as $key => $value) {
                        echo '         <tr>
            <td colspan="2">
            <small>&nbsp;',$key,
            ': ',$value,'</small><br>
            </td>
        </tr>',"\n";
                    }
                }
                else {
                    echo '      <table cellpadding="1" cellspacing="1">
         <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class="font2">',
            $str[21],':</font>&nbsp;&nbsp;
            </td>
            <td>
            ',$part_headers['subject'],'
            </td>
        </tr>
        <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class="font2">',
            $str[22],':</font>
            </td>
            <td>
            ',$part_headers['from'],'
            </td>
        </tr>
         <tr>
            <td>
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class="font2">',$str[23],':</font>
            </td>
            <td>
            ',date($date_string,(strtotime($part_headers['date']))),'
            </td>
        </tr>',"\n";
                    }
                }
                echo '      </table>
      </td>
   </tr>
   <tr>
      <td colspan="3">
      <table width="100%" cellpadding="1" cellspacing="1">
         <tr>
            <td nowrap colspan="3">&nbsp;&nbsp;&nbsp;&nbsp;',"\n";
                echo '            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
<table width="95%" align="center">
   <tr>
      <td class="tables4" colspan="3">',"\n";
        }
        switch (true) {
            case substr($dsp_type, 0, 5) == 'image':
                hm_print_image_part ($hm_input['id'], $hm_input['mailbox'],
                                     $hm_input['uid'], $hm_input['part'], $decode, 
                                     $type, $subtype, $name);
                break;
            case $dsp_type == 'texthtml':
                hm_print_html_part ($text_part, $charset_convert, $code_page, $charset,
                                    $message_headers, $hm_input['id']);
                break;
            case $dsp_type == 'textplain':
                hm_print_text_part ($text_part, $charset_convert, $code_page, $utf,
                                    $hm_input['id'], $hm_input['uid'], $hm_input['part'],
                                    $hm_input['mailbox']);
                break;
            default:
                echo '      <table width="97%" align="center">
         <tr>
            <td>
            </td>
         </tr>
      </table>',"\n";
                break;
        }
        $actual_parts[] = $hm_input['part'];
        $displayed[] = substr($hm_input['part'], 0, strrpos($hm_input['part'], '.'));
    }
}

echo '
      </td>
   </tr>
</table>
<br>
<table align="center" width="95%">
   <tr>
      <td>
      <small><a href="message.php?id=',$hm_input['id'],
      '&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
      '&amp;mailbox=',urlencode($hm_input['mailbox']),$full,$parts,
      $raw_value,'">
      ',$str[91],'
      </a></small>
      </td>
   </tr>
</table>
</body>
</html>',"\n";


hm_imap_logout($imap_stream); 

?>
