<?php

/* html_functions.php: Some functions for html generation 
*
    Copyright (C) 2002,2003,2004  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: html_functions.php,v 1.304 2004/08/18 20:08:50 sailfrog Exp $
*/

/**
 *  function to print out the message controls
 *
 *  @param      $dropdown_list  array           message selection options
 *  @param      $number         int             which set of controls (per page)
 *  @param      $simple         boolean         simple display mode flag
 *  @param      $dest           string          saved destination folder
 *  @param      $no_unread      boolean         skip "Unread" button if true
 *  @return                     void
 *
 */
function hm_print_message_controls($dropdown_list, $number, $simple, $dest,
                                   $no_unread=false) {
    $str = $_SESSION['str'];
    if ($number == 2) {
        $read = 'read2';
        $flag = 'flag2';
        $unflag = 'unflag2';
        $unread = 'unread2';
        $delete = 'delete2';
        $copy = 'copy2';
        $move = 'move2';
        $destination = 'destination2';
        $selection_type = 'selection_type2';
        $skip_trash = 'skip_trash2';
    }
    else {
        $read = 'read';
        $unread = 'unread';
        $flag = 'flag';
        $unflag = 'unflag';
        $delete = 'delete';
        $copy = 'copy';
        $move = 'move';
        $destination = 'destination';
        $selection_type = 'selection_type';
        $skip_trash = 'skip_trash';
    }
    /*echo '                  <input class="button3" type="submit" name="toggle_all" ', 
     'value="',$str[246],'">&nbsp;&nbsp;*/
    echo'             <select name="',$selection_type,'" class="select3">',"\n";
    foreach ($dropdown_list as $index => $val) {
        echo '                     <option class="option3" value="',$index,'">',
             $val,"</option>\n";
    }
    echo '                  </select>&nbsp;
                  <input type="submit" class="button3" name="',$read,'" value="',
     $str[2],'"> ';
    if (!$no_unread) {
       echo '<input type="submit" class="button3" name="',$unread,'" value="',
            $str[3],'"> ';
    }
    echo '<input type="submit" class="button3" name="',$flag,'" value="',$str[325],
    '">&nbsp;<input type="submit" class="button3" name="',$unflag,'" value="',$str[326],
    '">&nbsp;<input type="submit" class="button3" name="',$delete,'" value="',
     $str[4],'">&nbsp;<input type="submit" class="button3" name="',$copy,'" value="',
     $str[1],'">-<input type="submit" class="button3" name="',$move,'" value="',
     $str[0],'">-&gt;<select class="select3" name="',$destination,'">';
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo "                  </select>&nbsp;\n";
    if (isset($_SESSION['settings']['trash_folder']) && 
        isset($_SESSION['settings']['skip_trash'])) {
        echo '                  <small>',$str[311],
             '</small> <input type="checkbox" value="1" name="',$skip_trash,'">&nbsp;',
             "\n";
    }
}

/**
 *  function to print out folder option elements for select boxes
 *
 *  @param      $mailbox    string|array    currently selected mailbox(s)
 *  @param      $unseen     array|boolean   unseen data array, or false
 *  @param      $simple     boolean         simple display mode flag
 *  @param      $enc        boolean         if true option values are urlencoded
 *  @param      $style      string          css style to use for the option elements
 *  @return                 void
 *
 */ 
function hm_folder_options($mailbox, $unseen=false, $simple=false, $enc=false, 
                           $css_style='', $selectable=false) {
    $delim = $_SESSION['delimiter'];
    $folders = $_SESSION['folders'];
    $dsp_folders = $_SESSION['dsp_folders'];
    if ($selectable) {
        $no_sel = array_diff($folders, $selectable);
    }
    else {
        $no_sel = $_SESSION['nosel_folders'];
    }
    $new_mail_folders = array();
    if (isset($_SESSION['settings']['new_mail_folders'])) {
        $new_mail_folders = $_SESSION['settings']['new_mail_folders'];
    }
    $detail = 'new';
    if (isset($_SESSION['settings']['folder_detail'])) {
        $detail = $_SESSION['settings']['folder_detail'];
    }
    $style = 'nested';
    if (isset($_SESSION['settings']['folder_style'])) {
        $style = $_SESSION['settings']['folder_style'];
    } 
    foreach($folders as $folder) {
        echo '                  <option ',$css_style,' value="';
        if ($enc) {
            echo urlencode($folder);
        }
        else {
            echo $folder;
        }
        if (in_array($folder, $no_sel)) {
            echo ' " DISABLED >';
        }
        elseif (!is_array($mailbox) && 
                (urlencode($folder) == $mailbox || $folder == $mailbox)) {
            echo '" SELECTED >';
        }
        elseif (is_array($mailbox) && in_array($folder, $mailbox)) {
            echo '" SELECTED >';
        }
        else {
            echo '">';
        }
        if (!$simple && substr_count($dsp_folders[$folder], $delim) > 0 &&
            $style == 'nested') {
            $pos = strrpos($dsp_folders[$folder], $delim);
            echo str_repeat('&nbsp;', intval($pos/2)),'|_ ';
            if (isset($_SESSION['config']['utf7_decode'])) {
                echo utf8_encode(imap_utf7_decode(substr($dsp_folders[$folder],
                     ($pos + 1))));
            }
            else {
                echo substr($dsp_folders[$folder], ($pos + 1));
            }
        }
        else {
            if (isset($_SESSION['config']['utf7_decode'])) {
                echo utf8_encode(imap_utf7_decode($dsp_folders[$folder]));
            }
            else {
                echo $dsp_folders[$folder];
            }
        }
        if ($unseen && $detail != 'none') {
            if (!isset($unseen[$folder])) {
                $unseen[$folder] = 0;
            }
            if (in_array($folder, $new_mail_folders)) {
                if ($detail == 'total') {
                    echo '&nbsp;&nbsp;('.$unseen[$folder].
                         '/'.$_SESSION['message_count'][$folder].')';
                }
                else {
                    echo '&nbsp;&nbsp;('.$unseen[$folder].')';
                }
            }
        }
        echo "</option>\n";
    }
}

/**
 *  function to output the top of each page, html title etc. and the toolbar
 *
 *  @param      $imap_stream    resource    conneciton to imap
 *  @param      $mailbox        string      currently selected folder
 *  @param      $unseen         array       unseen array
 *  @param      $refresh        boolean     add refresh meta tag
 *  @param      $page_name      string      name of the calling script
 *  @param      $warning        string      a warning/notice for hm_print_error()
 *  @param      $big_form       boolean     true if we don't want to close the HTML form
 *  @return                     void
 *
 */
function hm_toolbar($imap_stream, $mailbox, $unseen, $refresh=false, $page_name=false,
                    $warning=false, $uid=false, $big_form=false) {
    $config = $_SESSION['config'];
    $settings = $_SESSION['settings'];
    $str = $_SESSION['str'];
    if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 
        'true') || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 
        'true')) {
        $simple = true;
    }
    else {
        $simple = false;
    }
    if (!isset($settings['css_file'])) {
        if (!isset($config['default_theme']) || $config['default_theme'] == '') {
            $settings['css_file'] = 'default.css';
        }
        else {
            $settings['css_file'] = $config['default_theme'];
        }
    }

    /* work around old theme setting */
    $css = str_replace(array('_large', '_small'), '', strtolower($settings['css_file']));
    if (isset($settings['font_size'])) {
        if ($settings['font_size'] < 3) {
            switch ($settings['font_size']) {
                case 0:
                    $settings['font_size'] = 11;
                case 1:
                    $settings['font_size'] = 9;
                case 2:
                    $settings['font_size'] = 12;
                default:
                    $settings['font_size'] = 11;
            }
        }
    }    
    else {
        $settings['font_size'] = 11;
    }
     
    if (isset($settings['refresh_new'])) {
        $refresh_new = $settings['refresh_new'] * 60;
    }
    else { 
        $refresh_new = 60;
    }
    if (isset($config['page_title'])) {
        $title = $config['page_title'];
    }
    else {
        $title = 'Hastymail';
    }
    if ($page_name) {
        $title = $page_name.' | '.$title;
    }
    if ($uid) {
        if (!isset($_SESSION['current_uid'])) {
            $_SESSION['current_uid'] = array();
        }
        $_SESSION['current_uid'][$mailbox] = $uid;
    }
    $total = 0;
    foreach ($unseen as $index => $value) {
        $total += $value;
    }
    if (isset($settings['date_string'])) {
        $date_string = $settings['date_string'];
    }
    else {
        $date_string = 'g:i:s a m/d/y';
    }
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");             
    header("Content-Type: text/html; charset=".$str['charset']);

    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>
      ',
        $str[10],' (',$total,') | ',$title,'
  </title>
  <meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=',$str['charset'],'">',"\n";
    if ($refresh && ($refresh_new != 0)) {
        echo '  <meta HTTP-EQUIV="refresh" content="',$refresh_new,';url=',
            $config['hostname'],$config['install_path'],
            'new.php?mailbox=',urlencode($mailbox),'&amp;id=',session_id(),"\">\n";
    }
    if (!$simple) {
        echo '  <link rel="stylesheet" type="text/css" href="../html/style.php?style='.
             $css.'&amp;size='.$settings['font_size'].'">';
    }
    echo '<link rel="SHORTCUT ICON" href="../images/hastymail.ico">
</head>
<body>
<a name="top"></a>
<form action="redirect.php" method="post">',"\n";
    if (!$simple) {
        echo '
<table width="100%" align="center">
   <tr>
      <td class="tables2" width="1%">
      <table align="center" width="100%" cellpadding="2" cellspacing="2" class="tables1">
         <tr>
            <td align="center" ';
        if (isset($settings['wide_bar']) && $settings['wide_bar'] == 'true') {
            echo 'rowspan="2" valign="top" width="29">',"\n";
        }
        else {
            echo 'valign="middle" width="29">',"\n";
        }
echo '            <a href="about.php?id=',session_id(),'&amp;mailbox=',$mailbox,'">
            <img src="../images/hastymail.png" width="28" height="23" border="0" alt="H">
            </a>
            </td>',"\n";
        if (isset($settings['show_clock']) && $settings['show_clock'] == 'true') {
            echo '            <td align="center" nowrap valign="middle">
            <table class="tables2" cellpadding="2" cellspacing="0">
               <tr>
                  <td class="tables1" nowrap>
                  <small>&nbsp;',date($date_string),'&nbsp;</small>
                  </td>
               </tr>
            </table>
            </td>',"\n";
        }
        echo '            <td nowrap valign="middle">',"\n";
    }
    echo '            <select name="toolbar_mailbox">',"\n";
    hm_folder_options($mailbox, $unseen, $simple, true);
    echo '            </select>
            &nbsp;&nbsp;
            <input type="submit" name="go" value="',$str[5],'" class="button1">
            <input type="hidden" name="id" value="',session_id(),'">',"\n";
    if (!$simple) {
        echo '            </td>',"\n";
        if (isset($settings['wide_bar']) && $settings['wide_bar'] == 'true') {
            echo '<td width="75%"></td></tr><tr><td></td>';
        }
        echo '            <td colspan="2" align="right" nowrap>',"\n";
        $search = '            <input type="submit" name="search" value="'.$str[11].
                      '" class="button1">'."\n";
    }
    else {
        $search = '';
    }
    $tb_defaults = ($_SESSION['toolbar_defaults']);
    if ($tb_defaults['new']) {
        echo '            <input type="submit" name="new" value="',
             $str[10],' (',$total,')','" class="button1">',"\n";
    }
    if ($tb_defaults['search']) {
        echo $search;
    }
    if ($tb_defaults['options']) {
        echo '            <input type="submit" name="options" value="',
             $str[12],'" class="button1">',"\n";
    }
    if ($tb_defaults['folders']) {
        echo '            <input type="submit" name="folders" value="',
             $str[13],'" class="button1">',"\n";
    }
    if ($tb_defaults['contacts']) {
        echo '            <input type="submit" name="contacts" value="',
             $str[14],'" class="button1">',"\n";
    }
    if ($tb_defaults['compose']) {
        echo '            <input type="submit" name="compose" value="',
             $str[15],'" class="button1">',"\n";
    }
    if ($tb_defaults['new_session']) {
        echo '            <input type="submit" name="new_session" value="',
             'New SID','" class="button1">',"\n";
    }
    echo '            <input type="submit" name="logout" value="',
         $str[16],'" class="button1">
            <input type="hidden" name="id" value="',session_id(),'">
            <input type="hidden" name="mailbox" value="',$mailbox,'">
            <input type="hidden" name="hostname" value="',$config['hostname'],'">
            <input type="hidden" name="install_path" value="',
            $config['install_path'],'">',"\n";
    if (!$simple) {
        echo "            </td>
        </tr>\n";
        hm_print_error($simple, $warning);
        echo '    </table>
    </td>
</tr>
</table>',"\n";
        if (isset($config['iframe']) && $config['iframe'] == 'true' && 
           (!$refresh || $refresh_new == 0)) {
            echo '<iframe src="iframe.php?id=',session_id(),
         '" width="0" height="0" frameborder="0" style="{display: none}">
</iframe>',"\n";
        }
    }
    else {
        hm_print_error($simple, $warning);
    }
    if (!$big_form) {
        echo '</form>',"\n";
    }
    
}

/**
 *  check for errors and print them out
 *
 *  @param      $simple     boolean     status of simple mode display
 *  @param      $warning    string      warning/notice from the calling script
 *  @return                 void        prints errors under the toolbar
 *
 */
function hm_print_error($simple, $warning) {
    $str = $_SESSION['str'];
    if ($simple) {
        $start = '<br>';
        $stop = '<br>';
    }
    else {
        $start = '<tr><td colspan="4" align="center">';
        $stop = '</td></tr>'."\n";
    }
    if (empty($_SESSION['notices'])) {
        return;
    }
    else {
        echo $start;
        foreach($_SESSION['notices'] as $index => $val) {
            echo '<b>'.preg_replace("/<br>$/", '', $val),'</b><br>';
        }
        echo $stop;
        $_SESSION['notices'] = array();
    }
    if ($warning && $warning != '') {
        echo $start,$warning,$stop;
    }
}

/**
 * Prints out the column headers for a message listing
 *
 *  @param      $mailbox        string      current folder
 *  @return                     void
 *
 */
function hm_start_message_listing ($mailbox) {
    $str = $_SESSION['str'];
    /* checkbox */
    $col_1 = '            <td>
            &nbsp;
            </td>'."\n";
    /* subject */
    $col_2 = '            <td colspan="2" width="50%">
            &nbsp;&nbsp;&nbsp;<small><b>'.$str[21].'</b></small>
            </td>'."\n";
    /* from or to */
    $col_3 = '            <td width="25%">'."\n";
    if (isset($_SESSION['settings']['sent_folder']) && 
        ($_SESSION['settings']['sent_folder'] == urldecode($mailbox))) {
        $col_3 .= "            &nbsp;&nbsp;<b><small>".$str[25]."</small></b>\n";
    }
    else {
        $col_3 .= "            &nbsp;&nbsp;<b><small>".$str[22]."</small></b>\n";
    }
    $col_3 .= '            </td>'."\n";
    /* date */
    $col_4 = '            <td width="19%">
            &nbsp;&nbsp;<b><small>'.$str[23].'</small></b>
            </td>'."\n";
    /* size */
    $col_5 = '            <td width="5%">
            &nbsp;&nbsp;<b><small>'.$str[24].'</small></b>
            </td>'."\n";
    /* flags */
    $col_6 = '            <td width="1%">
            &nbsp;&nbsp;
            </td>'."\n";
    echo $col_1,$col_2,$col_3,$col_4,$col_5,$col_6;
    /*for ($i=1;$i<7;$i++) {
        if (!isset($_SESSION['settings']['pos_'.$i])) {
            $name = 'col_'.$i;
            echo $$name;
        }
        else {
            switch ($_SESSION['settings']['pos_'.$i]) {
                case 'checkbox':
                    echo $col_1;
                    break;
                case 'subject':
                    echo $col_2;
                    break;
                case 'from':
                    echo $col_3;
                    break;
                case 'date':
                    echo $col_4;
                    break;
                case 'size':
                    echo $col_5;
                    break;
                case 'flags':
                    echo $col_6;
                    break;
                default:
                    break;
            }
        }
    }*/
}

/**
 *  Print out one row of message details
 *
 *  @param      $headers        array       message header data
 *  @param      $simple         boolean     simple mode flag
 *  @param      $t_all          boolean     toggle all flag
 *  @param      $mailbox        string      current mailbox
 *  @param      $id             string      session id
 *  @param      $uid            int         message id
 *  @param      $sort_info      array       sort information for thread view
 *  @param      $current        boolean     true if this message is the last one viewed
 *  @param      $ref            array       thread sorting reference array
 *  @param      $row            int         current row for thread sorting
 *  @param      $message_page   boolean     message page flag
 *  @param      $up             string      uid for the up arrow link (false for none)
 *  @param      $down           string      uid for the down arrow link (false for none)
 *  @param      $cur_uid        string      real uid used when called with message_page
 *  @return                     void
 *
 */
function hm_print_row($headers, $simple, $t_all, $mailbox, $id, $uid, $sort_info=array(),
                      $hilite=true, $chk_folder=false, $search=false, $thread=false, 
                      $current=false, $ref=array(), $row=false, $message_page=false) {
    $str = $_SESSION['str'];
    $col_1 = '';
    $col_2 = '';
    $col_3 = '';
    $col_4 = '';
    $col_5 = '';
    $col_6 = '';
    list ($subject, $from, $date, $priority, $content, 
         $flags, $to, $size, $int_date) = $headers;
    if (!$current && !$message_page) {
        if (isset($_SESSION['current_uid'][$mailbox]) &&
            $uid == $_SESSION['current_uid'][$mailbox]) {
            $current=true;
        }
    }
    if ($message_page) {
        $start = '<small>';
        $stop  = '</small>';
    }
    else {
        $start = '';
        $stop  = '';
    }
    if ($subject == '') {
        $subject = $str[229];
    }
    $priority = ltrim($priority);
    $from = hm_address_dsp($from, $str[230]);
    $to = hm_address_dsp($to, $str[232]);
    if (!strstr($subject, ' ') && strlen($subject) > 100) {
        $subject = substr($subject, 0, 100).' '.substr($subject, 100);
    }
    if (isset($_SESSION['settings']['subject_size']) && strlen($subject) >
        $_SESSION['settings']['subject_size'] && $_SESSION['settings']['subject_size'] >
        0) {
        $subject = substr($subject, 0, $_SESSION['settings']['subject_size']).'...';
    }
    if (!stristr($flags, 'seen')) {
        $new = 1;
        if ($hilite) {
            $class = 'tables6';
            $font = 'class="font2"';
        }
        else {
            $class = 'tables3';
            $font = 'class="font1"';
        }
    }
    else {
        $new = 0;
        $class = 'tables3';
        $font = 'class="font1"';
    }
    if (!stristr($flags, 'answered')) {
        $ans = false;
    }
    else {
        $ans = true;
    }
    if (!stristr($flags, 'flagged')) {
        $flagged = false;
    }
    else {
        $flagged = true;
    }
    echo '         <tr>',"\n";
    /* print out a table row */
    if (!$simple && !$thread) {
        $col_1 .= '            <td valign="top" width="1%" class="'.$class.
                 '" nowrap>'."\n";
    }
    elseif (!$simple) {
        $col_1 .= '            <td class="'.$class.'" nowrap>'."\n";
    }
    else {
        $col_1 .= "            <td>\n";
    }
    /* checkbox */
    if (!$thread && !$message_page) {
        if (!$chk_folder) {
            $col_1 .= '            <input type="checkbox" name="'.$uid.
                 '" value="mark" class="'.$class.'" ';
            if ($t_all) {
                if (!isset($_POST[$uid])) {
                    $col_1 .= 'CHECKED ';
                }
            }
        }
        else {
            $col_1 .= '            <input type="checkbox" name="'.$chk_folder.
                 '[]" value="'.$uid.'" class="'.$class.'" ';
            if ($t_all) {
                if (!isset($_POST[$chk_folder])) {
                    $col_1 .= 'CHECKED ';
                }
                else {
                    if (!in_array($uid, $_POST[$chk_folder])) {
                        $col_1 .= 'CHECKED ';
                    }
                }
            }
        }
        $col_1 .= ">\n";
    }
    else {
        $col_1 .= '&nbsp;';
    }
    $tag = 'mailbox='.urlencode($mailbox).'&amp;id='.urlencode($id).
           '&amp;new='.$new.'&amp;uid='.$uid;
    if ($search) {
        $tag .= '&amp;search=1';
    }
    if ($thread) {
        $tag .= '&amp;thread=1';
    }
    /* current message arrow */
    if (!$simple) {
        $col_1 .= '            </td>'."\n";
        $col_2 .= '            <td width="1%" class="'.$class.
                  '" nowrap valign="top">'."\n";
        if ($current) {
            $col_2 .= '            -&gt;';
        }
        else {
            $col_2 .= "            &nbsp;&nbsp;&nbsp;\n";
        }
        $col_2 .= '            </td>
            <td class="'.$class.'" valign="top">'."\n";
    }
    /* thread lines */
    if (isset($sort_info[3]) && isset($sort_info[3][$uid])) {
        if ($sort_info[3][$uid] > 1) {
            $range = array_slice($ref, $row); 
            $remaining = $range;
            $place = array();
            foreach ($range as $index => $val) {
                if ($val < $sort_info[3][$uid]) {
                    $add = true;
                    foreach ($remaining as $v) {
                        if ($v == $val) {
                            $add = true;
                            break;
                        }
                        if ($v < $val) {
                            $add = false;
                            break;
                        }
                    }
                    if ($add) {
                        $place[] = $val;
                    }
                }
            }
            $string = str_repeat("_", $sort_info[3][$uid]);
            foreach ($place as $value) {
                $string{$value} = '|';
            }
            $string = str_replace('_', '&nbsp;&nbsp;&nbsp;', $string);
            $string = str_replace('|', '|&nbsp;&nbsp;&nbsp;', $string);
            $col_2 .= "            <font class=\"font1\">$string|_</font>&nbsp;\n";
        }
    }
    if ($simple) {
        if ($new) {
            $col_2 .= '<b>';
        }
    }
    /* subject */
    $col_2 .= '            <a '.$font.' href="message.php?'.$tag.'">
        '.$start.'    '.$subject.$stop.' </a>'."\n";
    /* from (or to for sent folder) */
    if (!$simple) {
        $col_2 .= '            </td>'."\n";
        $col_3 .= '            <td class="'.$class.'" valign="top">'."\n";
    }
    else {
        if ($new) {
            $col_2 .= '</b>';
        }
        $col_2 .= "            <br>\n";
    }
    if (isset($_SESSION['settings']['sent_folder']) &&
             ($_SESSION['settings']['sent_folder'] == urldecode($mailbox))) {
        $col_3 .= '           &nbsp;&nbsp;'.$start.'<font '.$font.'>'.$to.
                  '</font>'.$stop."\n";
    }
    else {
        $col_3 .= '            &nbsp;&nbsp;'.'<font '.$font.'>'.$start.$from.
                  $stop.'</font>'."\n";
    }
    /* date */
    if ($simple) {
        $col_3 .= "<br>\n";
    }
    else {
        $col_3 .= '            </td>'."\n";
        $col_4 .= '            <td valign="top" nowrap class="'.$class.'">'."\n";
    }
    $col_4 .= '            &nbsp;&nbsp;';
    if (!$simple) {
        $col_4 .= '<font '.$font.'>';
    }
    $col_4 .= $start.hm_htmlize($date).$stop;
    if (!$simple) { 
        $col_4 .= '</font>
            </td>'."\n";
        $col_5 .= '            <td valign="top" class="'.$class.
                 '" nowrap>
            <font '.$font.">";
    }
    /* size */
    if ($simple) {
        $col_5 .= "            <br>\n            &nbsp;&nbsp;";
    }
    else {
        $col_5 .= '&nbsp;';
    }
    if ($size != '') {
        $col_5 .= $start.hm_size_format($size).$stop;
    }
    $col_5 .= "&nbsp;</font>\n";
    if (!$simple) {
        $icons = '';
        if (stristr($content, 'multipart') || stristr($content, 'mixed')) {
            $icons .= '<b><small>+&nbsp;</small></b>';
        }
        if ($ans) {
            $icons .= '<b><small>r&nbsp;</small></b>';
        }
        if ($flagged) {
            $icons .= '<b><small>F&nbsp;</small></b>';
        }
        if (strlen($priority) > 0 && $priority{0} < 3) {
            $icons .= '<b><font color="red"><small>!&nbsp;</small></font></b>';
        }
        $col_5 .= '            </td>'."\n";
        $col_6 .= '            <td class="'.$class.
                  '">
            '.$icons.'&nbsp;
            </td>
         </tr>'."\n";
    }
    else {
        $col_6 .= "            </td>
         </tr>\n";
    }
    if ($message_page) {
        echo '<td></td>';
    }
    echo $col_1,$col_2,$col_3,$col_4,$col_5,$col_6;
    /*for ($i=1;$i<7;$i++) {
        if (!isset($_SESSION['settings']['pos_'.$i])) {
            $name = 'col_'.$i;
            echo $$name;
        }
        else {
            switch ($_SESSION['settings']['pos_'.$i]) {
                case 'checkbox':
                    echo $col_1;
                    break;
                case 'subject':
                    echo $col_2;
                    break;
                case 'from':
                    echo $col_3;
                    break;
                case 'date':
                    echo $col_4;
                    break;
                case 'size':
                    echo $col_5;
                    break;
                case 'flags':
                    echo $col_6;
                    break;
                default:
                    break;
            }
        }
    }*/
}
?>
